#!/usr/local/bin/perl

#=============================================================================#
# oCi_v : Binary Dump (bin_dump.pl)                                  #
#                                                                             #
# oCieLXg(16 byte Ƃ hexAascii)Ƃă_v               #
# (v̓oCiGfB^ɃeLXgo͂)                                  #
#                                                                             #
# Edited by tazawa                                                            #
#                                                                             #
# 2002.04.18 - Ver 0.1   : Ƃ肠쐬                                     #
# 2002.04.30 - Ver 0.2   : 낢Ə                                 #
#=============================================================================#

#-----------------------------------------------------------------------------#
# ݒ荀                                                                    #
#-----------------------------------------------------------------------------#
my $src = "";  # ftHg̏t@C

#-----------------------------------------------------------------------------#
# O[o錾                                                              #
#-----------------------------------------------------------------------------#
# W[
use strict;  # ϐ錾̋

#-----------------------------------------------------------------------------#
# C                                                                  #
#-----------------------------------------------------------------------------#
$src = $ARGV[0] if($ARGV[0]);
die 'usage : perl bin_dump.pl <binary-file>' unless(defined($src));

open(BIN, $src) or die "Can't Open $src. Because $!";
binmode(BIN);

my $size = -s $src;
my $fmt  = "%08x: ";

my $dest = "$src.txt";
open(TXT, ">$dest");

my @val;

for(my $i = 0; $i < $size; $i += 16)
{
	print TXT sprintf($fmt, $i);

	seek(BIN, $i, 0);
	read(BIN, my $tmp, 16);

	# oCi HEX o
	my $hex = unpack("H32", $tmp);

	for(my $k = 0; $k < 16; $k++)
	{
		my $val;

		my $val = substr($hex, $k * 2, 2);
		print TXT "$val ";
		push(@val, $val);
	}

	# oCi ASCII o
	print TXT "    ";

	my $len;

	if($i + 16 >= $size)  # Ō
	{
		$len = 16 - $size % 16;
		print TXT "  " x $len;
		$len = $size % 16;
	}

	for(my $j = 0; $j < 16; $j++)
	{
		$val[$j] = "00" if(defined($len) and $j >= $len);  # _~[

		if($val[$j] =~ /[019A-F]./)
		{
			print TXT " ";
		}
		else
		{
			print TXT pack("c", hex($val[$j]));
		}
	}

	@val = ();

	# s
	print TXT "\n";
}

close(BIN);
close(TXT);

